## AP3 td5bis correction


## heap sort

# format: li is a list, p and stop are index positions; li[:stop] must
# be "heaped" at position 2p+1 and 2p+2 if those are less than the
# stop index; placeroot(li,p,stop) modifies li *in place* such that
# li[:stop] is "heaped" at position p.
def placeroot(li,p,stop):
  g,d = 2*p+1,2*p+2
  if g > stop: return None
  else:
    k = g if (d>stop or li[g]>li[d]) else d
    if li[k]>li[p]:
      li[k],li[p] = li[p],li[k]
      placeroot(li,k,stop)
    return None

# format: li is a list; heapify(li) modifies li *in place* such that
# li is a heap at the end (i.e. "heaped" at every position).
def heapify(li):
  stop = len(li) - 1
  for p in range(stop/2,-1,-1):
    placeroot(li,p,stop)
  return None 

# format: li is a list; heapsort(li) modifies li *in place* such that
# li is sorted at the end. The sorting algorithm is the heap sort: it
# is a selection sort with a preprocessing making li a heap; then the
# search of maximum inside the selection sort is done logarithmically
# instead of linearly.
def heapsort(li):
  heapify(li)
  for n in range(len(li)-1,-1,-1):
    li[n],li[0] = li[0],li[n]
    placeroot(li,0,n-1)
  return None

import random 
li = [random.randrange(1,100) for i in range(20)]
print li
heapsort(li)
print li
